#
#  Copyright (c) 2008 INdT - Instituto Nokia de Tecnologia
#
#  This file is part of carman-python.
#
#  carman-python is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  carman-python is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from common.carlog import DEBUG
from main.messagedlgctrl import MessageDlgController
from models.infosharingmodel import InfoSharingModel


class DeleteAccountController(object):

    def __init__(self, parent):
        self._parent = parent
        self.is_service = InfoSharingModel().service

    def __del__(self):
        DEBUG("deleting DeleteAccountController %s" % self)

    def exist_account(self):
        account = self.is_service.get_account()

        if not account:
            msg = MessageDlgController()
            msg.show_message("No account saved", title="DELETE ACCOUNT")
            return False

        self.acc = account
        return True

    def delete_account(self):
        def delete():
            self.is_service.remove_account()
            self._parent.hide(True)
            self._parent._parent.hide(True)

        def disconnect_account():
            self.is_service.account_disconnect()
            delete()

        if self.is_service.account_is_enabled():
            msg = MessageDlgController(confirm_cb=disconnect_account)
            msg.show_message("This account is currently active.<br>" \
                    "Disconnect and delete<br>%s?" % self.acc[0].split("/")[0], \
                    buttons=2, title="DELETE ACCOUNT")
        else:
            msg = MessageDlgController(confirm_cb=delete)
            msg.show_message("Do you want to delete account <br>%s?" % \
                    self.acc[0].split("/")[0], buttons=2, title="DELETE ACCOUNT")
